/*------------------------------------------------------------------------------
 Copyright:      Radig Ulrich  mailto: mail@ulrichradig.de
 Author:         Radig Ulrich
 Remarks:        
 known Problems: none
 Version:        24.10.2007
 Description:    Commando Interpreter
------------------------------------------------------------------------------*/

#include "cmd.h"

volatile signed int variable[3];
char cmd_buffer[50];

CMD_ITEM CMD_TABLE[] = // Befehls-Tabelle
{
	{"RESET",command_reset},
	{"ARP",command_arp},
	{"TCP",command_tcp},
	{NULL,NULL} 
};

//------------------------------------------------------------------------------
//Zeichenprfung auf Trennzeichen
unsigned char is_space (char ch)
{
	
	return (ch == ' ' || ch == ',');
}

//------------------------------------------------------------------------------
//Nchstes Trennzeichen suchen und String abschliessen
char* cmd_skip_chars(char *sptr)
{
	while (*sptr && !is_space(*sptr)) sptr++;
	if (*sptr) // Wenn noch kein Stringende erreicht ist,
		*sptr++ = 0; // dann String mit 0 abschliessen und Zeiger erhhen
	return sptr;
}

//------------------------------------------------------------------------------
//Commando auswerten
unsigned char cmd_exec(char *pstr)
{
	//Stringzeiger;
	char *ps;
	char *pdest;
	
	ps = pstr;
	pdest = cmd_buffer;

	while(*ps != 0)
	{
		*pdest++ = *ps++;
	}
	*pdest = '\0';
	
	unsigned char cmd_index = 0; // Befehlsindex
 
	//Anfangsposition von Token in ps speichern
	ps = pstr;  
	//Stringende suchen und abschliessen
	pstr = cmd_skip_chars(pstr);


	//Stringvergleich mit Befehlsliste durchfhren
	while (CMD_TABLE[cmd_index].cmd && strcasecmp(CMD_TABLE[cmd_index].cmd,ps))
	{ 
		cmd_index++;
	}
	usart_write("\r\n");
	// Wenn Befehlsindex zu gross, dann mit Fehler beenden
	if (!CMD_TABLE[cmd_index].cmd)
	{ 
		return(0);
	}
   
	CMD_TABLE[cmd_index].fp(); // Befehl ausfhren und Ergebnis zurckgeben
	return(1); 
}

//------------------------------------------------------------------------------
//Reset ausfhren
void command_reset (void)
{
	RESET();
}

//------------------------------------------------------------------------------
//print ARP table
void command_arp (void)
{
	for (unsigned char index = 0;index<MAX_ARP_ENTRY;index++)
	{
		usart_write("%2i  MAC:%2x",index,arp_entry[index].arp_t_mac[0]);
		usart_write(".%2x",arp_entry[index].arp_t_mac[1]);
		usart_write(".%2x",arp_entry[index].arp_t_mac[2]);
		usart_write(".%2x",arp_entry[index].arp_t_mac[3]);
		usart_write(".%2x",arp_entry[index].arp_t_mac[4]);
		usart_write(".%2x",arp_entry[index].arp_t_mac[5]);
		
		usart_write("  IP:%3i",(arp_entry[index].arp_t_ip&0x000000FF));
		usart_write(".%3i",((arp_entry[index].arp_t_ip&0x0000FF00)>>8));
		usart_write(".%3i",((arp_entry[index].arp_t_ip&0x00FF0000)>>16));
		usart_write(".%3i",((arp_entry[index].arp_t_ip&0xFF000000)>>24));
			
		usart_write("  Time:%4i\r\n",arp_entry[index].arp_t_time);
	}
}

//------------------------------------------------------------------------------
//print ARP table
void command_tcp (void)
{
	for (unsigned char index = 0;index<MAX_TCP_ENTRY;index++)
	{
		usart_write("%2i",index);
		usart_write("  IP:%3i",(tcp_entry[index].ip&0x000000FF));
		usart_write(".%3i",((tcp_entry[index].ip&0x0000FF00)>>8));
		usart_write(".%3i",((tcp_entry[index].ip&0x00FF0000)>>16));
		usart_write(".%3i",((tcp_entry[index].ip&0xFF000000)>>24));
		usart_write("  PORT:%4i",LBBL_ENDIAN_INT(tcp_entry[index].src_port));
		usart_write("  Time:%4i\r\n",tcp_entry[index].time);
	}
}











